package com.V10lator.SignClock;

import java.util.ArrayList;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.Material;
import org.bukkit.World;

public class triggerTicker extends Thread {
	private final SignClock plugin;
	public triggerTicker(final SignClock plugin)
	{
	  this.plugin = plugin;
	}
	
	public void run()
	{
		
		int cl = 0;
		int worlds = plugin.triggerRAM.getTriggerWorlds();
		while(cl < worlds)
		{
		  String sWorld = plugin.triggerRAM.getTriggerWorld().get(cl);
		  ArrayList<Integer> sCoords = plugin.triggerRAM.getTriggerCoords().get(cl);
		  

		  World world = plugin.getServer().getWorld(sWorld);
		  Block block = world.getBlockAt(sCoords.get(0), sCoords.get(1), sCoords.get(2));
		  if(block.getType() == Material.SIGN_POST || block.getType() == Material.WALL_SIGN)
          {
		    Sign sign = (Sign)block.getState();
		    SClock SClock = plugin.getSignClock(block);
		    //Set next state
		    String libout = null;
		    if(SClock.isDaytime())
		      libout = plugin.l24t.getDaytime(plugin.getServer().getWorld(sWorld));
		    else
		 	  libout = plugin.l24t.getTime(plugin.getServer().getWorld(sWorld));
		 
	        //write the new lines
		    String frame = plugin.themeLib.getFrame(SClock.getStyle()).replace("[TIM]", libout);
	        String zeilen[] = frame.split("\n");
	        sign.setLine(0, "");
	        sign.setLine(1, "");
	        sign.setLine(2, "");
	        sign.setLine(3, "");
	        int fl = zeilen.length;
	        int c = 0;
	        while(c < fl)
	        {
	          if(c > 3)
	    	    break;
	          if(zeilen[c] != null)
	          {
	        	if(zeilen[c].length() > 15)
	              sign.setLine(c, zeilen[c].substring(0,14));
	          	else
	           	  sign.setLine(c, zeilen[c]);
	          }
	          c++;
	        }

	        sign.update();
		  }
	      cl++;
		}
	}
}
